#include <cstdio>
#include <algorithm>

#define MAX_K 20

using namespace std;

int k;
bool mazejantis[MAX_K];//mažesnė kriterijaus reikšmė yra geriau

int n;

int gnr = 0;//geriausio automobilio numeris
bool gtikras = false;//ar geriausias automobilis yra tikras
int dk[MAX_K], gk[MAX_K];//dabartinio ir geriausio (fiktyvaus) automobilių kriterijai

void dgeresnis(int nr) {
	gnr = nr;
	for (int i = 0; i < k; ++i)
		gk[i] = dk[i];
	gtikras = true;
}

void dlygus(int nr) {
	gnr = 0;
}

void dnepalyginamas(int nr) {
	gnr = 0;
	for (int i = 0; i < k; ++i)
		if (mazejantis[i])
			gk[i] = min(gk[i], dk[i]);
		else
			gk[i] = max(gk[i], dk[i]);
	gtikras = false;
}

int main() {
	scanf("%d", &k);
	getchar();//praleidžiame eilutės galo simbolį
	for (int i = 0; i < k; ++i) {
		char c = getchar();
		mazejantis[i] = c == 'M';
	}

	scanf("%d", &n);
	for (int nr = 1; nr <= n; ++nr) {
		int kger = 0;//geresnių kriterijų skaičius
		int kblog = 0;//blogesnių kriterijų skaičius
		for (int i = 0; i < k; ++i) {
			scanf("%d", &dk[i]);
			if (dk[i] != gk[i]) {
				if ((mazejantis[i] && dk[i] < gk[i]) || (!mazejantis[i] && dk[i] > gk[i]))
					kger++;
				else
					kblog++;
			}
		}
		if (nr == 1 || (kger > 0 && kblog == 0)) {
			//rastas geresnis
			dgeresnis(nr);
		}
		else if (kger > 0 && kblog > 0) {
			//rastas nepalyginamas
			dnepalyginamas(nr);
		}
		else if (kger == 0 && kblog == 0) {
			//rastas lygus
			if (gtikras) {
				dlygus(nr);
			}
			else
				dgeresnis(nr);
		}
	}

	if (gnr != 0)
		printf("%d\n", gnr);
	else
		printf("Neegzistuoja\n");
	return 0;
}
